<template>
    <MdDialog
            class="error-container"
            style="z-index: 200"
            :md-active.sync="active"
    >
        <MdDialogContent>
            <div class="error-header">
                <md-icon class="md-size-3x">bug_report</md-icon>
                <MdDialogTitle>{{$t('main.errorDetailsTitle')}}</MdDialogTitle>
            </div>
            <MdDialogContent>
                <ErrorDetailEntry i18n-key="main.errorType" :value="exceptionType" />
                <ErrorDetailEntry i18n-key="main.errorMsg" :value="errorMsg" />
            </MdDialogContent>
        </MdDialogContent>
        <MdDialogActions>
            <MdButton class="md-primary md-raised error-button" @click="reload()">{{$t('main.errorReload')}}</MdButton>
            <MdButton class="md-primary md-raised error-button" @click="close()">{{$t('main.errorClose')}}</MdButton>
        </MdDialogActions>
    </MdDialog>
</template>
<script>
  import Vue from 'vue';
  import { MdDialog } from 'vue-material/dist/components'
  import jsLog from 'js-logger';

  const log = jsLog.get('ErrorDialog');

  Vue.use(MdDialog);

  const ErrorDetailEntry = {
    template: `
        <div class="error-detailsEntry">
            <div class="error-detailsEntryCategory">
                {{$t(i18nKey)}}
            </div>
            <div class="error-detailsEntryValue">
                {{value}}
            </div>

        </div>
    `,
    props: {
      i18nKey: {
        type: String,
        isRequired: true
      },
      value: {
        type: String,
        isRequired: true
      }
    }
  };

  export default {
    props: {
      show: {
        type: Boolean,
        default: false
      }
    },
    computed: {
      active: {
        get(){
          return this.show;
        },
        set(active){
          if (!active) this.close();
        }
      },
      errorMsg() {
        return this.$store.state.request.error && this.$store.state.request.error.errorMsg;
      },
      exceptionType() {
        return this.$store.state.request.error && this.$store.state.request.error.exceptionType;
      }
    },
    components: { ErrorDetailEntry },
    methods: {
      close(){
        log.info('close');
        this.$store.dispatch('closeErrorDetails');
        this.$router.push({ query: {}});
      },
      reload(){
        window.location.reload();
      }
    }
  }
</script>
<style>
    .error-container{
        z-index: 2000;
    }
    .error-header, .error-header > * {
        color: var(--md-theme-default-fieldvariant) !important;
        margin-bottom: 20px;
    }

    .error-detailsEntry {
        margin: 0px 4px;
        color: var(--md-theme-default-fieldvariant) !important;
    }

    .error-detailsEntryCategory {
        font-weight: bold;
        font-size: 14px;
    }

    .error-detailsEntryValue {
        font-size: 10px;
        margin-left: 20px;
    }
    .error-button{
        background-color: var(--md-theme-default-fieldvariant) !important;
    }
</style>
